package com.example.pepdemo

import android.os.Bundle
import android.util.Log
import android.widget.Button
import android.widget.EditText
import androidx.appcompat.app.AppCompatActivity
import com.pep.core.foxitpep.PepApp
import com.pep.core.foxitpep.activity.PEPBookActivity
import com.pep.core.foxitpep.config.StaticCascadeConfig
import com.pep.core.foxitpep.db.model.Section
import com.pep.core.foxitpep.manager.BookDownLoadManager
import com.pep.core.foxitpep.model.StaticCascadeModel
import com.pep.core.uibase.PEPToast
import kotlinx.android.synthetic.main.activity_home.*


class HomeActivity : AppCompatActivity() {

    private lateinit var btnOpen: Button
    private lateinit var btnDown: Button
    private lateinit var btnGetBooks: Button
    private lateinit var btnGetGetBookProgress: Button
    private lateinit var btnGetStaticMetadataBean: Button
    private lateinit var btnRemoveBookDownload: Button
    private lateinit var btnUpdateBook: Button
    private lateinit var btnDeleteBooks: Button
    private lateinit var btnGetSections: Button
    private lateinit var etBooks: EditText
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_home)
        etBooks = findViewById<EditText>(R.id.et_books)


        btnOpen = findViewById(R.id.btn_open)
        btnOpen.setOnClickListener {
            PEPBookActivity.invoke(this@HomeActivity, etBooks.text.toString())
        }
        btnDown = findViewById(R.id.btn_down)
        btnDown.setOnClickListener {
            BookDownLoadManager.getInstance().downLoadBook(etBooks.text.toString())
        }

        btnGetBooks = findViewById<Button>(R.id.btn_get_books)
        btnGetBooks.setOnClickListener {
            val books = PepApp.getBookDataBase().getBookDao().getBooks(PepApp.getCurrentUserId(), false)
            PEPToast.show(applicationContext, books.toString())
        }
        btnGetGetBookProgress = findViewById<Button>(R.id.btn_get_getBookProgress)
        btnGetGetBookProgress.setOnClickListener {
//            val bookProgress = BookDownLoadManager.getInstance().getBookProgress(etBooks.text.toString())
//            if (bookProgress == null) {
//                PEPToast.show(applicationContext, "当前未执行下载操作")
//            } else {
//                PEPToast.show(applicationContext, "当前下载进度" + bookProgress.toString())
//            }

            BookDownLoadManager.getInstance().addOnDownloadListener(et_books.text.toString(),object :BookDownLoadManager.OnDownloadListener{
                override fun onProgressStatus(bookId: String?, progress: Long, speed: String?, status: Int) {
                    Log.e("Tag", "onProgressStatus: "+bookId+"---"+progress+"---"+status )
                }

            },"AAA");
        }
        btnGetStaticMetadataBean = findViewById<Button>(R.id.btn_getStaticMetadataBean)
        btnGetStaticMetadataBean.setOnClickListener {
            StaticCascadeConfig.getStaticMetadataBean(object : StaticCascadeConfig.OnStaticCascadeListener {
                override fun onData(staticCascadeModel: StaticCascadeModel?) {
                    if (staticCascadeModel != null) {
                        PEPToast.show(applicationContext, staticCascadeModel.toString())
                    }
                }
            })
        }

        btnRemoveBookDownload = findViewById<Button>(R.id.btn_removeBookDownload)
        btnRemoveBookDownload.setOnClickListener {
            BookDownLoadManager.getInstance().removeBookDownload(etBooks.text.toString())
        }
        btnUpdateBook = findViewById<Button>(R.id.btn_updateBook)
        btnDeleteBooks = findViewById<Button>(R.id.btn_deleteBooks)
        btnDeleteBooks.setOnClickListener {
            BookDownLoadManager.getInstance().deleteBooks(etBooks.text.toString())
        }
        btnGetSections = findViewById<Button>(R.id.btn_getSections)
        btnGetSections.setOnClickListener {
            StaticCascadeConfig.getSections(this@HomeActivity, etBooks.text.toString(), object : StaticCascadeConfig.OnSectionDataListener {
                override fun onSucess(sections: MutableList<Section>?) {
                    PEPToast.show(applicationContext, sections.toString())
                }

                override fun onError() {
                    PEPToast.show(applicationContext, "获取章节列表失败")
                }
            })
        }

    }

}
